-----------------------------------------------------------------------------------------------
-- Client Lua Script for QuickPerformance
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- QuickPerformance Module Definition
-----------------------------------------------------------------------------------------------
local QuickPerformance = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function QuickPerformance:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function QuickPerformance:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- QuickPerformance OnLoad
-----------------------------------------------------------------------------------------------
function QuickPerformance:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("QuickPerformance.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- QuickPerformance OnDocLoaded
-----------------------------------------------------------------------------------------------
function QuickPerformance:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "QuickPerformanceForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("quickp", "OnQuickPerformanceOn", self)
	    Apollo.RegisterSlashCommand("quickp-on", "OnOK", self)
		Apollo.RegisterSlashCommand("quickp-off", "OnCancel", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- QuickPerformance Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/quickp"
function QuickPerformance:OnQuickPerformanceOn()
	self.wndMain:Invoke() -- show the window
end


-----------------------------------------------------------------------------------------------
-- QuickPerformanceForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function QuickPerformance:OnOK()
	Apollo.SetConsoleVariable("lod.renderTargetScale", 0.5)
	Apollo.SetConsoleVariable("spell.visualSuppression", 0.75) 
	self.wndMain:FindChild("HelpText"):SetText("Performance boost ON!")
	Print("QuickPerformance ON!")
end	

-- when the Cancel button is clicked
function QuickPerformance:OnCancel()
	Apollo.SetConsoleVariable("lod.renderTargetScale", 1.0)
	Apollo.SetConsoleVariable("spell.visualSuppression", 0) 
	self.wndMain:FindChild("HelpText"):SetText("Performance boost Off!")
	Print("QuickPerformance OFF!")
end

function QuickPerformance:OnClose()
	self.wndMain:Close()
end

-----------------------------------------------------------------------------------------------
-- QuickPerformance Instance
-----------------------------------------------------------------------------------------------
local QuickPerformanceInst = QuickPerformance:new()
QuickPerformanceInst:Init()
